/*
 * ==========================================================================================
 * hash.h
 *
 * Date: 09 July 2003
 * Author: Jerome Delamarche
 * Version: 2.0 
 * ------------------------------------------------------------------------------------------
 *
 * Interface for the hash array management
 *
 * ------------------------------------------------------------------------------------------
 * CHANGES:
 *
 * ------------------------------------------------------------------------------------------
 * TODO:
 *
 * ==========================================================================================
 */
#ifndef _benchmark_hash_h_
#define _benchmark_hash_h_

typedef struct _MYHASHENTRY {
	char			*key;
	struct _MYHASHENTRY	*next;	/* to handle the collision */
	void			*data;	/* opaque structure */
} MYHASHENTRY;

#define HASHSIZE	1024 /* the hash coding function must return a value between 0 and 1023 */

typedef MYHASHENTRY *MYHASH[HASHSIZE];

/*
 * Exported functions:
 */
MYHASH *HashAllocate();
void HashFree(MYHASH *hash);
void *HashGetEntryOf(MYHASH *hash, const char *key);
void *HashAddEntry(MYHASH *hash, const char *key, int size);
void HashDump(MYHASH *hash, void (*cback)(int, const char *, void *, void *), void *opaque);
int HashValue(const char *key);

#endif /* _benchmark_hash_h_ */

/* EOF */
