/*
 * ==========================================================================================
 * interf.h
 *
 * Date: 09 July 2003
 * Author: Jerome Delamarche
 * Version: 1.0 
 * ------------------------------------------------------------------------------------------
 *
 * Describes the structure of the exchanged message between mod_benchmark and benchmark_rt
 *
 * ------------------------------------------------------------------------------------------
 * CHANGES:
 *
 * ------------------------------------------------------------------------------------------
 * TODO:
 *
 * ==========================================================================================
 */
#ifndef _benchmark_interf_h_
#define _benchmark_interf_h_

/*
 * Structure of a message send by the module to benchmark_rt:
 */
typedef struct {
	/* data from mod_benchmark: */
	int	mtype;		/* 1st field of struct msgbuf */
	int	status;		/* HTTP status code */
	int 	sec;		/* count of seconds to handle the request */
	int 	usec;		/* count of micro-seconds to handle the request */
	int	sready;		/* count of currently running instances of Apache */
	int	sbusy;		/* count of currently busy instances of Apaches */
	char   	url[256];	/* NULL terminated URL maxsize of 256 bytes */

	/* data from sysstat2: */
	int	sysvalid;	/* 1=following datae are valid */
	int	zombie;		/* count of zombie process */
	int	running;	/* count of running process */
	int	stopped;	/* count of stopped process */
	int	sleeping;	/* count of sleeping process */
	int	avgload;	/* average CPU load (base 1000) */
	int	memuse;		/* percentage of used memory (base 1000) */
	int	swapuse;	/* percentage of used swap (base 1000) */

	/* data from scoreboard: */
	int	sbvalid;	/* 1=following datae are valid */
	int	server_ready;	/* count of ready instances of Apache server */
	int 	server_busy;	/* count of busy instances of Apache server */
} BenchmarkMsg;

#endif /* _benchmark_interf_h_ */

/* EOF */
